// BonTuner.cpp: CBonTuner NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <InitGuid.h>
#include "BonTuner.h"

#pragma comment(lib, "ws2_32.lib")



#define BITRATE_CALC_TIME	500		//ms
inline DWORD DiffTime(DWORD BeginTime,DWORD EndTime)
{
	if (BeginTime<=EndTime)
		return EndTime-BeginTime;
	return (0xFFFFFFFFUL-BeginTime)+EndTime+1UL;
}

//////////////////////////////////////////////////////////////////////
// 萔`
//////////////////////////////////////////////////////////////////////

// ~[ebNX
#define MUTEX_NAME			TEXT("BonDriver_HTTP")



// FIFOobt@ݒ
#define ASYNCBUFFTIME		2											// obt@ = 2b
#define ASYNCBUFFSIZE		( 0x200000 / TSDATASIZE * ASYNCBUFFTIME )	// 16MbpsƂ

#define REQRESERVNUM	    8				// 񓯊NGXg\ //before 16
#define REQPOLLINGWAIT		20				// 񓯊NGXg|[OԊu(ms) //before 10

// 񓯊NGXg
#define IORS_IDLE			0x00			// NGXg
#define IORS_BUSY			0x01			// NGXgM	
#define IORS_RECV			0x02			// MAXgA҂


//////////////////////////////////////////////////////////////////////
// CX^X\bh
//////////////////////////////////////////////////////////////////////

extern "C" __declspec(dllexport) IBonDriver * CreateBonDriver()
{
	// X^X(̏ꍇ̓CX^X̃|C^Ԃ)
	return (CBonTuner::m_pThis)? CBonTuner::m_pThis : ((IBonDriver *) new CBonTuner);
}


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

// ÓIo
CBonTuner * CBonTuner::m_pThis = NULL;
HINSTANCE CBonTuner::m_hModule = NULL;

CBonTuner::CBonTuner()
	: m_bTunerOpen(false)
	, m_hMutex(NULL)
	, m_pIoReqBuff(NULL)
	, m_pIoPushReq(NULL)
	, m_pIoPopReq(NULL)
	, m_pIoGetReq(NULL)
	, m_dwBusyReqNum(0UL)
	, m_dwReadyReqNum(0UL)
	, m_hPushIoThread(NULL)
	, m_hPopIoThread(NULL)
	, m_hOnStreamEvent(NULL)
	, m_dwCurSpace(0UL)
	, m_dwCurChannel(0xFFFFFFFFUL)
	, m_sock(INVALID_SOCKET)
	, m_fBitRate(0.0f)
	, m_dwRecvBytes(0UL)
	, m_dwLastCalcTick(0UL)
{
	m_pThis = this;

	// NeBJZNV
	::InitializeCriticalSection(&m_CriticalSection);
}

CBonTuner::~CBonTuner()
{
	// JĂꍇ͕
	CloseTuner();

	// NeBJZNV폜
	::DeleteCriticalSection(&m_CriticalSection);

	// WinsockI
	if (m_bTunerOpen)
		WSACleanup();

	m_pThis = NULL;
}

const BOOL CBonTuner::OpenTuner()
{
	if (!m_bTunerOpen) {
		// Winsock
		WSADATA stWsa;
		if (WSAStartup(MAKEWORD(2,0),&stWsa) != 0)
			return FALSE;
		m_bTunerOpen = true;
	}

	//return SetChannel(0UL,0UL);

	return TRUE;
}

void CBonTuner::CloseTuner()
{
	// XbhIvZbg
	m_bLoopIoThread = FALSE;

	// CxgJ
	if (m_hOnStreamEvent) {
		::CloseHandle(m_hOnStreamEvent);
		m_hOnStreamEvent = NULL;
	}

	// XbhI
	if(m_hPushIoThread){
		if(::WaitForSingleObject(m_hPushIoThread, 1000) != WAIT_OBJECT_0){
			// XbhI
			::TerminateThread(m_hPushIoThread, 0);
			::OutputDebugString(TEXT("BonDriver_HTTP: CBonTuner::CloseTuner() ::TerminateThread(m_hPushIoThread)\n"));
			}

		::CloseHandle(m_hPushIoThread);
		m_hPushIoThread = NULL;
		}

	if(m_hPopIoThread){
		if(::WaitForSingleObject(m_hPopIoThread, 1000) != WAIT_OBJECT_0){
			// XbhI
			::TerminateThread(m_hPopIoThread, 0);
			::OutputDebugString(TEXT("BonDriver_HTTP: CBonTuner::CloseTuner() ::TerminateThread(m_hPopIoThread)\n"));
			}

		::CloseHandle(m_hPopIoThread);
		m_hPopIoThread = NULL;
		}


	// obt@J
	FreeIoReqBuff(m_pIoReqBuff);
	m_pIoReqBuff = NULL;
	m_pIoPushReq = NULL;
	m_pIoPopReq = NULL;
	m_pIoGetReq = NULL;

	m_dwBusyReqNum = 0UL;
	m_dwReadyReqNum = 0UL;

		// hCoN[Y
	if(m_sock != INVALID_SOCKET){
		closesocket(m_sock);
		m_sock = INVALID_SOCKET;
		}

	// `l
	m_dwCurSpace = 0UL;
	m_dwCurChannel = 0xFFFFFFFFUL;

	// ~[ebNXJ
	if(m_hMutex){
		::ReleaseMutex(m_hMutex);
		::CloseHandle(m_hMutex);
		m_hMutex = NULL;
		}

	m_fBitRate = 0.0f;
	m_dwRecvBytes = 0UL;
}

const DWORD CBonTuner::WaitTsStream(const DWORD dwTimeOut)
{
	// I`FbN
	if(!m_hOnStreamEvent || !m_bLoopIoThread)return WAIT_ABANDONED;

	// CxgVOiԂɂȂ̂҂
	const DWORD dwRet = ::WaitForSingleObject(m_hOnStreamEvent, (dwTimeOut)? dwTimeOut : INFINITE);

	switch(dwRet){
		case WAIT_ABANDONED :
			// `[iꂽ
			return WAIT_ABANDONED;

		case WAIT_OBJECT_0 :
		case WAIT_TIMEOUT :
			// Xg[擾\ or `[iꂽ
			return (m_bLoopIoThread)? dwRet : WAIT_ABANDONED;

		case WAIT_FAILED :
		default:
			// O
			return WAIT_FAILED;
		}
}

const DWORD CBonTuner::GetReadyCount()
{
	// o\TSf[^擾
	return m_dwReadyReqNum;
}

const BOOL CBonTuner::GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	BYTE *pSrc = NULL;

	// TSf[^obt@o
	if(GetTsStream(&pSrc, pdwSize, pdwRemain)){
		if(*pdwSize){
			::CopyMemory(pDst, pSrc, *pdwSize);
			}

		return TRUE;
		}

	return FALSE;
}

const BOOL CBonTuner::GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	if(!m_pIoGetReq)return FALSE;

	// TSf[^obt@o
	if(m_dwReadyReqNum){
		if(m_pIoGetReq->dwState == IORS_RECV){

			// f[^Rs[
			*pdwSize = m_pIoGetReq->dwRxdSize;
			*ppDst = m_pIoGetReq->RxdBuff;

			// obt@ʒui߂
			::EnterCriticalSection(&m_CriticalSection);
			m_pIoGetReq = m_pIoGetReq->pNext;
			m_dwReadyReqNum--;
			*pdwRemain = m_dwReadyReqNum;
			::LeaveCriticalSection(&m_CriticalSection);

			return TRUE;
			}
		else{
			// O
			return FALSE;
			}
		}
	else{
		// o\ȃf[^Ȃ
		*pdwSize = 0;
		*pdwRemain = 0;

		return TRUE;
		}
}

void CBonTuner::PurgeTsStream()
{
	// obt@o\f[^p[W

	::EnterCriticalSection(&m_CriticalSection);
	m_pIoGetReq = m_pIoPopReq;
	m_dwReadyReqNum = 0;
	::LeaveCriticalSection(&m_CriticalSection);
}

void CBonTuner::Release()
{
	// CX^XJ
	delete this;
}

LPCTSTR CBonTuner::GetTunerName(void)
{
	// `[iԂ
	return TEXT("HTTP/IPv4");
}

const BOOL CBonTuner::IsTunerOpening(void)
{
	// `[i̎gp̗LԂ(SvZXʂ)
	HANDLE hMutex = ::OpenMutex(MUTEX_ALL_ACCESS, FALSE, MUTEX_NAME);
	
	if(hMutex){
		// Ƀ`[i͊JĂ
		::CloseHandle(hMutex);
		return TRUE;
		}
	else{
		// `[i͊JĂȂ
		return FALSE;
		}
}

LPCTSTR CBonTuner::EnumTuningSpace(const DWORD dwSpace)
{
	// gp\ȃ`[jOԂԂ(IPv6͂܂ĂȂ)
	switch(dwSpace){
		case 0UL :	return TEXT("HTTP/IPv4");
	//	case 1UL :	return TEXT("HTTP/IPv6");
		default  :	return NULL;
		}
}

LPCTSTR CBonTuner::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel)
{
	// gp\ȃ`lԂ
	if(dwSpace > 0 || (dwChannel >= GetPrivateProfileInt(L"BonDriver_HTTP", L"CH_NUM", 0, L"./BonDriver_HTTP.ini" )))return NULL;
	static TCHAR buf[128];
	TCHAR istr[128];
	wsprintf(istr,L"NAME_%02d",dwChannel);
	GetPrivateProfileString(L"BonDriver_HTTP", istr, L"default", buf, sizeof(buf), L"./BonDriver_HTTP.ini" );
	return buf;
}

const DWORD CBonTuner::GetCurSpace(void)
{
	// ݂̃`[jOԂԂ
	return m_dwCurSpace;
}

const DWORD CBonTuner::GetCurChannel(void)
{
	// ݂̃`lԂ
	return m_dwCurChannel;
}

CBonTuner::AsyncIoReq * CBonTuner::AllocIoReqBuff(const DWORD dwBuffNum)
{
	if(dwBuffNum < 2)return NULL;

	// mۂ
	AsyncIoReq *pNewBuff = new AsyncIoReq [dwBuffNum];
	if(!pNewBuff)return NULL;

	// [NA
	::ZeroMemory(pNewBuff, sizeof(AsyncIoReq) * dwBuffNum);

	// N\z
	DWORD dwIndex;
	for(dwIndex = 0 ; dwIndex < ( dwBuffNum - 1 ) ; dwIndex++){
		pNewBuff[dwIndex].pNext= &pNewBuff[dwIndex + 1];
		}

	pNewBuff[dwIndex].pNext = &pNewBuff[0];

	return pNewBuff;
}

void CBonTuner::FreeIoReqBuff(CBonTuner::AsyncIoReq *pBuff)
{
	if(!pBuff)return;

	// obt@J
	delete [] pBuff;
}

DWORD WINAPI CBonTuner::PushIoThread(LPVOID pParam)
{
	CBonTuner *pThis = (CBonTuner *)pParam;

	DWORD dwLastTime = ::GetTickCount();

//	::OutputDebugString("CBonTuner::PushIoThread() Start!\n");

	// hCoTSf[^NGXg𔭍s
	while(pThis->m_bLoopIoThread){

		// NGXg҂K薢Ȃǉ
		if(pThis->m_dwBusyReqNum < REQRESERVNUM){

			// hCoTSf[^NGXg𔭍s(HTTPȂ̂ŎMv̂)
			if(!pThis->PushIoRequest(pThis->m_sock)){
				// G[
				break;
				}

		} else {
			// NGXg҂t̏ꍇ̓EFCg
			::Sleep(REQPOLLINGWAIT);
		}
	}

//	::OutputDebugString("CBonTuner::PushIoThread() End!\n");
	return 0;
}

DWORD WINAPI CBonTuner::PopIoThread(LPVOID pParam)
{
	CBonTuner *pThis = (CBonTuner *)pParam;

	// σNGXg|[OăNGXg
	while(pThis->m_bLoopIoThread){

		// σf[^΃NGXg
		if(pThis->m_dwBusyReqNum){

			// NGXg
			if(!pThis->PopIoRequest(pThis->m_sock)){
				// G[
				break;
				}
			}
		}

	return 0;
}

const BOOL CBonTuner::PushIoRequest(SOCKET sock)
{
	// hCoɔ񓯊NGXg𔭍s

	// I[v`FbN
	if(sock == INVALID_SOCKET)return FALSE;

	// NGXgZbg
	m_pIoPushReq->dwRxdSize = 0;

	// Cxgݒ
	::ZeroMemory(&m_pIoPushReq->OverLapped, sizeof(WSAOVERLAPPED));
	if(!(m_pIoPushReq->OverLapped.hEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL)))return FALSE;

	// HTTPMvXj_I
	DWORD Flags=0;
	WSABUF wsaBuf;
	wsaBuf.buf = (char*)m_pIoPushReq->RxdBuff;
	wsaBuf.len = sizeof(m_pIoPushReq->RxdBuff);
	if(SOCKET_ERROR==WSARecv(sock,&wsaBuf,1,&m_pIoPushReq->dwRxdSize,&Flags,&m_pIoPushReq->OverLapped,NULL)){
		int sock_err = WSAGetLastError();
		if(sock_err != ERROR_IO_PENDING){
			return FALSE;
			}
		}

	m_pIoPushReq->dwState = IORS_BUSY;

	// obt@ԍXV
	::EnterCriticalSection(&m_CriticalSection);
	m_pIoPushReq = m_pIoPushReq->pNext;
	m_dwBusyReqNum++;
	::LeaveCriticalSection(&m_CriticalSection);

	return TRUE;
}

const BOOL CBonTuner::PopIoRequest(SOCKET sock)
{
	// 񓯊NGXg

	// I[v`FbN
	if(sock == INVALID_SOCKET)return FALSE;

	// ԃ`FbN
	if(m_pIoPopReq->dwState != IORS_BUSY){
		// O
		return TRUE;
		}

	// NGXg擾
	DWORD Flags=0;
	const BOOL bRet = ::WSAGetOverlappedResult(sock, &m_pIoPopReq->OverLapped, &m_pIoPopReq->dwRxdSize, FALSE,&Flags);

	// G[`FbN
	if(!bRet){
		int sock_err = WSAGetLastError();
		if(sock_err == ERROR_IO_INCOMPLETE){
			// 
			::Sleep(REQPOLLINGWAIT);
			return TRUE;
			}
		}

	// MTCYZ
	m_dwRecvBytes += m_pIoPopReq->dwRxdSize;

	// rbg[gvZ
	if (DiffTime(m_dwLastCalcTick,::GetTickCount())>=BITRATE_CALC_TIME)
		CalcBitRate();

	// Cxg폜
	::CloseHandle(m_pIoPopReq->OverLapped.hEvent);

	if(!bRet){
		// G[
		return FALSE;
		}

	m_pIoPopReq->dwState = IORS_RECV;

	// obt@ԍXV
	::EnterCriticalSection(&m_CriticalSection);
	m_pIoPopReq = m_pIoPopReq->pNext;
	m_dwBusyReqNum--;
	m_dwReadyReqNum++;
	::LeaveCriticalSection(&m_CriticalSection);

	// CxgZbg
	::SetEvent(m_hOnStreamEvent);

	return TRUE;
}


// `lݒ
const BOOL CBonTuner::SetChannel(const BYTE bCh)
{
	return SetChannel((DWORD)0,(DWORD)bCh-13);
}

// `lݒ
const BOOL CBonTuner::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	// Lȃ`l
	if(dwSpace > 0 || (dwChannel >= GetPrivateProfileInt(L"BonDriver_HTTP", L"CH_NUM", 0, L"./BonDriver_HTTP.ini" )))
		return FALSE;

	// UN[Y
	CloseTuner();

	// obt@m
	if(!(m_pIoReqBuff = AllocIoReqBuff(ASYNCBUFFSIZE))){
		return FALSE;
		}

	// obt@ʒu
	m_pIoPushReq = m_pIoReqBuff;
	m_pIoPopReq = m_pIoReqBuff;
	m_pIoGetReq = m_pIoReqBuff;
	m_dwBusyReqNum = 0;
	m_dwReadyReqNum = 0;

	try{
		// hCoI[v
		m_sock = socket(AF_INET,SOCK_STREAM,0);
		if(m_sock==INVALID_SOCKET) throw 1UL;


		// URL 𕪉

		
		// Bind

		char deststr[128];
		int port_num;
		char sendpath[128];



		WCHAR whost[128],temp[128],wpath[128],istr[128];

		wsprintf(istr,L"HOST_%02d",dwChannel);
		GetPrivateProfileString(L"BonDriver_HTTP", istr, L"default", whost, sizeof(whost), L"./BonDriver_HTTP.ini" );
		wsprintf(istr,L"PORT_%02d",dwChannel);
		port_num = GetPrivateProfileInt(L"BonDriver_HTTP", istr, 0, L"./BonDriver_HTTP.ini");
		wsprintf(istr,L"PATH_%02d",dwChannel);
		GetPrivateProfileString(L"BonDriver_HTTP", istr, L"default", temp, sizeof(wpath), L"./BonDriver_HTTP.ini" );
		wsprintf(wpath,L"GET %s HTTP/1.0\r\n\r\n",temp);

		size_t i;
		wcstombs_s(&i, deststr, whost, 128);
		wcstombs_s(&i, sendpath, wpath, 128);
		
		struct sockaddr_in stAddr;
		stAddr.sin_family = AF_INET;
		stAddr.sin_port = htons(port_num);
		stAddr.sin_addr.S_un.S_addr = inet_addr(deststr);

		// DNS resolve
		if(stAddr.sin_addr.S_un.S_addr == 0xffffffff){
			struct hostent *host = gethostbyname(deststr);
			if(host == NULL) throw 1UL;
			unsigned long ** paddr = (unsigned long **) host->h_addr_list;
			while(*paddr != NULL){
				stAddr.sin_addr.S_un.S_addr = *(*paddr);
				if(connect(m_sock,(struct sockaddr*) &stAddr, sizeof(stAddr)) == 0){
					break;
				}
				paddr++;
			}
			if(*paddr == NULL) throw 1UL;
		}else {
			if(connect(m_sock, (struct sockaddr *)&stAddr, sizeof(stAddr))) {
				TCHAR szDebugOut[128];
				::wsprintf(szDebugOut, TEXT("BonDriver_HTTP: CBonTuner::OpenTuner() connect error %d\n"), WSAGetLastError());
				::OutputDebugString(szDebugOut);
				throw 1UL;
			}
		}



		if(send(m_sock, sendpath, (int)strlen(sendpath), 0) < 0){
			TCHAR szDebugOut[128];
			::wsprintf(szDebugOut, TEXT("BonDriver_HTTP: CBonTuner::OpenTuner() send error %d\n"), WSAGetLastError());
			::OutputDebugString(szDebugOut);
			throw 1UL;
		}

		// Cxg쐬
		if(!(m_hOnStreamEvent = ::CreateEvent(NULL, FALSE, FALSE, NULL)))throw 2UL;

		// XbhN
		DWORD dwPushIoThreadID = 0UL, dwPopIoThreadID = 0UL;
		m_hPushIoThread = ::CreateThread(NULL, 0UL, CBonTuner::PushIoThread, this, CREATE_SUSPENDED, &dwPopIoThreadID);
		m_hPopIoThread = ::CreateThread(NULL, 0UL, CBonTuner::PopIoThread, this, CREATE_SUSPENDED, &dwPushIoThreadID);

		if(!m_hPushIoThread || !m_hPopIoThread){
			if(m_hPushIoThread){
				::TerminateThread(m_hPushIoThread, 0UL);
				::CloseHandle(m_hPushIoThread);
				m_hPushIoThread = NULL;
				}

			if(m_hPopIoThread){
				::TerminateThread(m_hPopIoThread, 0UL);
				::CloseHandle(m_hPopIoThread);
				m_hPopIoThread = NULL;
				}

			throw 3UL;
			}

		// XbhJn
		m_bLoopIoThread = TRUE;
		if(::ResumeThread(m_hPushIoThread) == 0xFFFFFFFFUL || ::ResumeThread(m_hPopIoThread) == 0xFFFFFFFFUL)throw 4UL;

		// ~[ebNX쐬
		if(!(m_hMutex = ::CreateMutex(NULL, TRUE, MUTEX_NAME)))throw 5UL;
		}
	catch(const DWORD dwErrorStep){
		// G[
		TCHAR szDebugOut[1024];
		::wsprintf(szDebugOut, TEXT("BonDriver_HTTP: CBonTuner::OpenTuner() dwErrorStep = %lu\n"), dwErrorStep);
		::OutputDebugString(szDebugOut);

		CloseTuner();
		return FALSE;
		}

	// `lXV
	m_dwCurSpace = dwSpace;
	m_dwCurChannel = dwChannel;

	// TSf[^p[W
	PurgeTsStream();

	return TRUE;
}

// Mx(rbg[g)擾
const float CBonTuner::GetSignalLevel(void)
{
	CalcBitRate();
	return m_fBitRate;
}

void CBonTuner::CalcBitRate()
{
	DWORD dwCurrentTick=GetTickCount();
	DWORD Span=DiffTime(m_dwLastCalcTick,dwCurrentTick);

	if (Span>=BITRATE_CALC_TIME) {
		m_fBitRate=(float)(((double)m_dwRecvBytes*(8*1000))/((double)Span*(1024*1024)));
		m_dwRecvBytes=0;
		m_dwLastCalcTick = dwCurrentTick;
	}
	return;
}
